/*
 * Copyright (C) 2004 WIDE Project.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include "rc_malloc.h"
#include "vmbuf.h"
#include "rc_type.h"
#include "rc_net.h"
#include "rc_str.h"
#include "if_pfkeyv2.h"
#include "plog.h"
#include "pidfile.h"
#include "rbuf.h"
#include "if_spmd.h"
#include "rc_pcap.h"
#include "rc_queue.h"
#include "script.h"
#include "missing/missing.h"

#define RACOON_CONF	SYSCONFDIR "/racoon2/racoon2.conf"

extern int rct2isakmp_exmode __P((int));
extern int rct2app_action __P((int));
extern int app2rct_action __P((int));
extern int rct2pfk_satype __P((int));
extern int pfk2rct_satype __P((int));
extern int rct2ipproto_satype __P((int type));
extern int rct2pfk_authtype __P((int));
extern int rct2pfk_enctype __P((int));
extern int rct2pfk_comptype __P((int));
extern int rct2pfk_samode __P((int));
extern int pfk2rct_samode __P((int));
extern int rct2pfk_seclevel __P((int));
extern int rct2pfk_dir __P((int));
extern int pfk2rct_dir __P((int));
extern int rct2pfk_proto __P((int));
extern const char *rct2str __P((int type));

extern int rcf_get_remotebyindex __P((rc_vchar_t *, struct rcf_remote **));
extern int rcf_get_remotebyaddr __P((struct sockaddr *, rc_type, struct rcf_remote **));
extern int rcf_get_remotebypeersid __P((rc_type, rc_vchar_t *, rc_type,
					int (*)(rc_type, rc_vchar_t *, struct rc_idlist *),
					struct rcf_remote **));
extern void rcf_free_remote __P((struct rcf_remote *rminfo));
extern int rcf_get_selectorlist __P((struct rcf_selector **));
extern int rcf_get_selector __P((const char *, struct rcf_selector **));
extern int rcf_get_rvrs_selector __P((struct rcf_selector *, struct rcf_selector **));
extern void rcf_free_selector __P((struct rcf_selector *));
extern int rcf_get_resolvers __P((struct rc_addrlist **));
extern int rcf_get_dns_queries __P((struct rc_addrlist **));
extern int rcf_spmd_resolver __P((void));
extern int rcf_get_spmd_interfaces __P((struct rc_addrlist **dst));
extern int rcf_get_spmd_if_passwd(rc_vchar_t **);

extern int rcf_read __P((const char *, int));
extern int rcf_clean __P((void));

extern rc_vchar_t *rcf_readfile(const char *path, const char *errloc,
				int secret);

/* version.c */
extern const char *rc_version(void);
extern const char *rc_startmsg(void);
